/*
 * RealEstate in Flash with PHP
 * by PhilFlash - http://philflash.inway.fr
 *
 * Initial version in ColdFusion. See:
 *  - The Real Estate Sample Application - Part 1: Building the Search Functionality with Flash Forms
 *    http://www.macromedia.com/devnet/coldfusion/articles/flashforms.html
 *  - The Real Estate Sample Application - Part 2: Managing Property Listings Through Flash Forms
 *    http://www.macromedia.com/devnet/coldfusion/articles/flashforms_pt2.html
 *
 * More information. See AsFusion Blog:
 *  - http://www.asfusion.com/blog/entry/coldfusion-flash-forms-macromedia-2
 *
 */

import mx.controls.Button;
import mx.controls.Alert;
import mx.controls.ProgressBar;
import mx.controls.TextArea;
import mx.controls.TextInput;
import mx.controls.Label;
import mx.controls.ComboBox;
import mx.controls.CheckBox;
import mx.controls.DateField;
import mx.controls.RadioButtonGroup;

import mx.controls.DataGrid;
import mx.controls.gridclasses.DataGridColumn;
import mx.data.components.DataSet;
import mx.data.components.XMLConnector;

import mx.data.components.datasetclasses.DataSetError;
import mx.data.to.ValueListIterator;
import mx.styles.CSSStyleDeclaration;

import mx.utils.Delegate;

import inway.IwEncart;
import form.ApplicationForm;

class form.MainForm extends mx.screens.Form {

	public var listing_ds:DataSet;
	public var listing_dg:DataGrid;

	private var grid_ie:IwEncart;
	private var edit_ie:IwEncart;
	
	private var backButton:Button;	
	private var debugButton:Button;
	private var filtreButton:Button;

	private var address_ti:TextInput;
	private var city_ti:TextInput;
	private var zip_ti:TextInput;
	
	private var price_ti:TextInput;
	private var bedrooms_ti:TextInput;
	private var bathrooms_ti:TextInput;
	private var yearbuilt_ti:TextInput;
	private var mls_ti:TextInput;
	private var stories_ti:TextInput;
	private var footage_ti:TextInput;
	private var listed_df:DateField;
	private var description_ta:TextArea;
	
	private var edit_status:RadioButtonGroup;
	
	private var hasPool_chb:CheckBox;
	private var hasLaundry_chb:CheckBox;
	private var hasFireplace_chb:CheckBox;
	private var hasWalkInClosets_chb:CheckBox;
	
	private var state_cb:ComboBox;
	private var type_cb:ComboBox;
	
	private var domaines:Array;
	private var nationalite:Array;
	private var preferenceDom:Array;
	
	private var initPerformed:Boolean = false;
	
	// for remote operation
	private var editButton:Button;
	private var removeButton:Button;	
	private var addButton:Button;
	
	public var operation_con:XMLConnector;
	
	private var componentError:Object;
	private var mandatoryComponents:Array;
	private var mandatoryMC:MovieClip;
	private var actionMessage:Label;
	
	// Constructor
	public function MainForm() {}

	public function init():Void {
		super.init();
		addEventListener("reveal", onReveal);
	}

	// -----   ----- 	
	public function onLoad(obj:Object):Void {
		setVisible(true);
		//
		componentError = null;
		mandatoryComponents = new Array();
		
		// -- Textfield --
		address_ti.maxChars = 100;
		city_ti.maxChars = 50;
		zip_ti.maxChars = 5;
		stories_ti.maxChars = 50;		
		description_ta.maxChars = 600;
		
		//
		grid_ie.setStyle("styleName", "h1");
		edit_ie.setStyle("styleName", "h1");
		
		grid_ie.setHeaderGradient(0x277DC6,0x50ABF7);
		edit_ie.setHeaderGradient(0x277DC6,0x50ABF7);
		// --
		var labels:Array = ["addressTitle_lbl", "status_lbl", "amenities_lbl", "listing_lbl", "description_lbl"];
		var len:Number = labels.length;
 		for (var i:Number = 0; i < len; i++) {
 			var component = this[labels[i]];
			component.setStyle("styleName", "label");
		}
		// --	
		listing_dg.addEventListener("change", Delegate.create(this, doListingChangeAction));
		listing_ds.addEventListener("afterLoaded", Delegate.create(this, doListingAfterLoadedAction));
		listing_ds.addEventListener("modelChanged", Delegate.create(this, doListingModelChangedAction));

		editButton.addEventListener("click", Delegate.create(this, doEditAction));
		removeButton.addEventListener("click", Delegate.create(this, doRemoveAction));
		addButton.addEventListener("click", Delegate.create(this, doAddAction));
		
		// ---
		operation_con.addEventListener("status", Delegate.create(this, doStatusOperationAction));	
		operation_con.addEventListener("result", Delegate.create(this, doResultOperationAction));

	
		//
		(rootForm).state_con.addEventListener("stateComplete", Delegate.create(this, doStateCompleteAction));
		// --
		listing_dg.editable = false;
		listing_dg.multipleSelection = false; 

		initStyleGrid(listing_dg);
		initColumnGrid(listing_dg); 
		// --
		var typeArray:Array = [];
		typeArray.push({label:"Condo/Townhouse", data:"Condo/Townhouse"});
		typeArray.push({label:"Single Family Home", data:"Single Family Home"});
		typeArray.push({label:"Multi-Family Home", data:"Multi-Family Home"});
 		type_cb.dataProvider = typeArray;
 	}
 	
	// -----   -----   	
	public function onReveal(obj:Object):Void {
		setMode("reset");
	}
	
	// -----   -----
	public function initStyleGrid(datagrid:DataGrid):Void {
		datagrid.setStyle("alternatingRowColors", Array(0xEAEFF4, 0xF8FAFB));

		datagrid.setStyle("hGridLines", true);
		datagrid.setStyle("hGridLineColor", 0xC1D1E0);
		datagrid.setStyle("vGridLines", true);
		datagrid.setStyle("vGridLineColor", 0xC1D1E0);

		datagrid.setStyle("borderStyle", "inset");
		// haut
		datagrid.setStyle("buttonColor", 0xFFFFFF);
		datagrid.setStyle("highlightColor", 0xFFFFFF);
		// cote
		datagrid.setStyle("borderCapColor", 0xFFFFFF);
		datagrid.setStyle("shadowCapColor", 0xFFFFFF);
		// bas
		datagrid.setStyle("shadowColor", 0x336699);
		datagrid.setStyle("borderColor", 0xFFFFFF);

		// If you want header
		// Header style
		var styleHeader:CSSStyleDeclaration= new mx.styles.CSSStyleDeclaration();
		styleHeader.styleName = "myHeader";
		styleHeader.fontFamily = "Verdana";
		styleHeader.fontSize = 10;
		styleHeader.fontWeight = "bold";
		//styleHeader.textAlign = "center";
		styleHeader.color = 0x336699;
		_global.styles["myHeader"] = styleHeader;

		datagrid.setStyle("headerStyle", styleHeader);
		datagrid.setHeaderHeight(20);
	}
	
	// -----  -----
	public function initColumnGrid(datagrid:DataGrid):Void {
		var newColumn:mx.controls.gridclasses.DataGridColumn;
		
		datagrid.removeAllColumns();

   		var cw = Math.floor((datagrid.width-18)/5); // 18 for vertical scrollbar
  
		newColumn = new mx.controls.gridclasses.DataGridColumn("type");
		newColumn.headerText = "Type";
		newColumn.width = cw;
		datagrid.addColumn(newColumn);
		
		newColumn = new mx.controls.gridclasses.DataGridColumn("price");
		newColumn.headerText = "Price   ";
		newColumn.width = cw;
		datagrid.addColumn(newColumn);

		newColumn = new mx.controls.gridclasses.DataGridColumn("bedrooms");
		newColumn.headerText = "Bedrooms   ";
		newColumn.width = cw;
		datagrid.addColumn(newColumn);		
		
		newColumn = new mx.controls.gridclasses.DataGridColumn("bathrooms");
		newColumn.headerText = "Bathrooms   ";
		newColumn.width = cw;
		datagrid.addColumn(newColumn);
		
		newColumn = new mx.controls.gridclasses.DataGridColumn("footage");
		newColumn.headerText = "Footage   ";
		newColumn.width = cw;
		datagrid.addColumn(newColumn);
		//
		var col = datagrid.getColumnAt(1);
		col.setStyle("textAlign", "right");	
		
		col = datagrid.getColumnAt(2);
		col.setStyle("textAlign", "right");	
		
		col = datagrid.getColumnAt(3);
		col.setStyle("textAlign", "right");	
		
		col = datagrid.getColumnAt(4);
		col.setStyle("textAlign", "right");	
	}
	
	// -----   -----
	public function doListingModelChangedAction(evt:Object):Void {
		grid_ie.title = "Properties ("+listing_ds.length+")";	
	}
	
	// -----   -----
	public function doListingAfterLoadedAction(evt:Object):Void {
		grid_ie.setStyle("styleName", "h1");
		doLater(this, "selectFirstRow");
	}
	
	public function selectFirstRow() {
		listing_dg.vPosition = 0;
		listing_dg.selectedIndex = (listing_dg.length > 0 ? 0 : undefined);
		listing_dg.dispatchEvent({type:"change"});
	}
	
	// -----   -----
	public function doListingChangeAction(eventObj:Object):Void {
		var target = eventObj.target;
		// -- clear previous edition if error --
		if (componentError != null) {
			resetLabels();
			componentError = null;
		}
		// --
		var selectedItem = target.selectedItem;
		if (selectedItem == undefined) {
			setMode("add");
		} else {
			setMode("edit");
			
			address_ti.text = selectedItem.address;
			city_ti.text = selectedItem.city;
			zip_ti.text = selectedItem.zipcode;
			selectOption(state_cb, selectedItem.state);
			
			price_ti.text = selectedItem.price;
			
			selectOption(type_cb, selectedItem.type);
			
			bedrooms_ti.text = selectedItem.bedrooms;
			bathrooms_ti.text = selectedItem.bathrooms;
			yearbuilt_ti.text = selectedItem.yearBuilt;
			mls_ti.text = selectedItem.id;			
			stories_ti.text = selectedItem.stories;
			footage_ti.text = selectedItem.footage;
			//
			description_ta.text = selectedItem.remarks;		
			
			edit_status.selectedData = selectedItem.status;
			
			hasPool_chb.selected = (selectedItem.hasPool == 1);
			hasLaundry_chb.selected = (selectedItem.hasLaundry == 1);
			hasFireplace_chb.selected = (selectedItem.hasFireplace == 1);
			hasWalkInClosets_chb.selected = (selectedItem.hasWalkInClosets == 1);
			
			var sd:String = selectedItem.listedOn;
			var date:Date = new Date( 0, 0, 0, 0, 0, 0 ); // exclude current time fix for bug#69845
			date.setYear(Number(sd.substr(6, 4)));
			date.setMonth(Number(sd.substr(3, 2))-1); // zero based
			date.setDate(Number(sd.substr(0, 2)));
					
			listed_df.selectedDate  = date;
		}
	}
	
	public function resetForm():Void {
		address_ti.text = "";
		city_ti.text = "";
		zip_ti.text = "";
		price_ti.text = "";

		bedrooms_ti.text = "";
		bathrooms_ti.text = "";
		yearbuilt_ti.text = "";
		mls_ti.text = "";			
		stories_ti.text = "1";
		footage_ti.text = "";
		description_ta.text = "";		

		state_cb.selectedIndex = 0;
		type_cb.selectedIndex = 0;
		//edit_status.selectedData = selectedItem.status;

		hasPool_chb.selected = false;
		hasLaundry_chb.selected = false;
		hasFireplace_chb.selected = false;
		hasWalkInClosets_chb.selected = false;

		listed_df.selectedDate  = new Date(); 
	}
	
	public function getEditObject():Object {
		var editArguments:Object = {};
		// --
		editArguments.id = mls_ti.text;
		editArguments.address = address_ti.text;
		editArguments.city = city_ti.text;
		editArguments.zipcode = zip_ti.text;
		editArguments.price = Number(price_ti.text);
		
		editArguments.stories = stories_ti.text;
		editArguments.bedrooms = Number(bedrooms_ti.text);
		editArguments.bathrooms = Number(bathrooms_ti.text);
		editArguments.footage = Number(footage_ti.text);
		editArguments.yearBuilt = Number(yearbuilt_ti.text);
		
		editArguments.listedOn = listed_df.selectedDate;
		
		// -- special case - remove newlines --
		var value = description_ta.text;
		value = value.split(newline ).join("");
		editArguments.remarks = value;
	
		// -- radio button --
		editArguments.status = edit_status.selectedData;
	
		// -- checkboxes --
		editArguments.hasPool = (hasPool_chb.selected ? 1 : 0);
		editArguments.hasWalkInClosets = (hasWalkInClosets_chb.selected ? 1 : 0);
		editArguments.hasLaundry = (hasLaundry_chb.selected ? 1 : 0);
		editArguments.hasFireplace = (hasFireplace_chb.selected ? 1 : 0);
	
		// -- combobox --
		editArguments.state = state_cb.value;
		editArguments.type = type_cb.value;
		
		return editArguments;
	}
	
	// Date : YYYY-MM-DD HH:MM:SS
	public function formatMySQLDate(d:Date) {
		var sMonth:String = ""+(d.getMonth()+1);
		if (sMonth.length == 1) { sMonth = "0"+sMonth; }
		//  
		var sDay:String = ""+d.getDate();
		if (sDay.length == 1) { sDay = "0"+sDay; }
		//  
		var sHour:String = ""+d.getHours();
		if (sHour.length == 1) { sHour = "0"+sHour; }
		//  
		var sMinute:String = ""+d.getMinutes();
		if (sMinute.length == 1) { sMinute = "0"+sMinute; }
		//  
		var sSecond:String = ""+d.getSeconds();
		if (sSecond.length == 1) { sSecond = "0"+sSecond; }
		//  
		return (d.getFullYear()+"-"+sMonth+"-"+sDay+" "+sHour+":"+sMinute+":"+sSecond);	
	}

	// -----  -----
 	public function check(Void):Boolean {
 		var checked:Boolean = true;
  		componentError = null;
 		// -- --
 		var fields:Array = [ "address", "city",   "zip",    "price", "mls",   "bedrooms", "bathrooms", "footage", "state", "yearbuilt" ];
 		var ftypes:Array = [ "string",  "string", "number", "number","string","number",   "number",    "number",  "cb",    "number"    ];
		var len:Number = fields.length;
		for (var i:Number = 0; i < len; i++) {
			var component = this[fields[i]+"_ti"];
			var label = this[fields[i]+"_lbl"];
			var type = ftypes[i];
			// Check String
			var inError:Boolean = false;
			if (type == "string") {
				var value = trimSpacer(component.text);
				component.text = value;
				if (value == "") {
					inError = true;
				}
			}
			else if (type == "number") {
				// Check Number
				var value = trimSpacer(component.text);
				component.text = value;
				var nvalue = parseInt(value);
				if (value == "" || isNaN(nvalue)) {
					inError = true;
				}
			}
			else if (type == "cb") {
				// Check Combobox
				component = this[fields[i]+"_cb"];
				var value = component.selectedIndex;
				if (value == 0) { 
					inError = true;
				}
			}
			// -- change look of label --
			if (inError) {
				checked = false;
				label.setStyle("styleName", "labelStyleError");
				if (componentError == null) {
					componentError = component;
				}
			} else {
				label.setStyle("styleName", "labelStyle");
			}				
		}
		return checked;
	}
	
	public function resetLabels():Void {
 		var fields:Array = [ "address", "city",   "zip",    "price", "mls",   "bedrooms", "bathrooms", "footage", "state", "yearbuilt" ];
		var len:Number = fields.length;
		for (var i:Number = 0; i < len; i++) {
			var label = this[fields[i]+"_lbl"];
			label.setStyle("styleName", "labelStyle");
		}
	}
	
	public function enabledMandatory(enabled:Boolean):Void {
		var len:Number = mandatoryComponents.length;
		if (len == 0) {
			// init 
 			var fields:Array = [ "address", "city",   "zip",    "price", "mls",   "bedrooms", "bathrooms", "footage", "state", "yearbuilt" ];
			len = fields.length;
			for (var i:Number = 0; i < len; i++) {
				var component = this[fields[i]+"_ti"];
				if (component == null) {
					component = this[fields[i]+"_cb"];
				}
				//				
				var mc = this.attachMovie("mandatory", "mand_" + i, this.getNextHighestDepth());
				mc._x = component._x - mc._width/3;
				mc._y = component._y;
				
				mandatoryComponents.push(mc);
			}
		}
		// show or hide
		for (var i = 0; i < len; i++) {
			mandatoryComponents[i]._visible = enabled;
		}
	}
			
	// -----   -----
	// States are loaded. A "stateComplete" event is received.
	public function doStateCompleteAction(eventObj:Object):Void {
		state_cb.dataProvider = eventObj.data;
	}

	// -----   -----	
	public function selectOption(select:ComboBox, optionToSelect:String):Void {
		var dp = select.dataProvider;
		var len = dp.length;
		var indice:Number = 0;
		for (var i:Number = 0; i<len; i++) {
			if (dp[i].data == optionToSelect) {
				indice = i;
				break;
			}
		}
		select.selectedIndex = indice;
	}
	
	// -----   -----
	// function that makes necessary changes to show add/edit toggle 
	public function setMode(mode:String):Void{
		if (mode == "add"){
			actionMessage.text = "You are currently adding a property";
			listing_dg.selectedIndex = undefined;
			edit_ie.backgroundColor =  0xCDE4F6;
			actionMessage.setStyle("color", 0x235986);
			resetForm();
			
			//
			editButton._visible = removeButton._visible = addButton._visible = true;
			editButton.label = "Submit";
			removeButton.enabled = false;
			addButton.enabled = false;
			
			enabledMandatory(true);
		}
		else if (mode == "edit") {
			actionMessage.text = "You are currently editing a property";
			edit_ie.backgroundColor = 0xCCDCF2;
			actionMessage.setStyle("color", 0x19316E);
			//
			editButton._visible = removeButton._visible = addButton._visible = true;
			editButton.label = "Apply Changes";
			removeButton.enabled = true;
			addButton.enabled = true;
			
			enabledMandatory(true);
		}
		else {
			actionMessage.text = "";
			edit_ie.backgroundColor =  0xCDE4F6;
			editButton._visible = removeButton._visible = addButton._visible = false;
			resetForm();
			
			enabledMandatory(false);
		}
	}
	
	// -----   -----
	public function doEditAction(eventObj:Object):Void {
		if (!check()) {
			if (componentError) {
				Selection.setFocus(componentError);		
			}
			return;
		}
		// Prepare XML
		var operationXML:XML = new XML("<?xml version=\"1.0\" encoding=\"UTF-8\" ?><operation></operation>");
		var rootNode = operationXML.firstChild;		
		
		rootNode.attributes.opcode = (editButton.label == "Submit" ? "insert" : "update");

		// Create XML for the object with some modifications
		var obj:Object = getEditObject();
		var node = operationXML.createElement("values");
		for (var f in obj) {
			if (f == "id") {
				node.attributes["mls_id"] = obj[f];	
			} 
			else if (f == "listedOn") {
				node.attributes[f] = formatMySQLDate(obj[f]);	
			} 
			else {
				node.attributes[f] = obj[f];
			}
		}
		rootNode.appendChild(node);
		
		// Send XML
		operation_con.params = operationXML;
		operation_con.trigger();
		// 
		enableProgress(true, "Update database...");
	}
	
	public function doAddAction(eventObj:Object):Void {
		setMode("add");
	}
	
	// -----   -----
	public function doRemoveAction(eventObj:Object):Void {
		// Check 
		var selectedItem = listing_dg.selectedItem;
		if (selectedItem == undefined) {	
			return;
		}
		// --
		var name:String = selectedItem.id;
		var message:String = "Remove '"+name+"'. Are you sure ?";
		
		var confirm:Alert = Alert.show(message, "Remove", Alert.OK | Alert.CANCEL, this, this.confirmRemoveHandler, null, Alert.OK);
		confirm.owner = this;
		confirm.startDragging = function() {};
		// 
		(rootForm).setLocationRelativeTo(confirm, eventObj.target);	
	}
	
	public function confirmRemoveHandler(eventObj:Object):Void {
		var detail = eventObj.detail;
		var target = eventObj.target;
		if (detail == Alert.OK || detail == Alert.YES) {
			target.owner.doRemoveOperation();
		}
	}
	
	public function doRemoveOperation():Void {
		var selectedItem = listing_dg.selectedItem;
		
		// Prepare XML
		var operationXML:XML = new XML("<?xml version=\"1.0\" encoding=\"UTF-8\" ?><operation></operation>");
		var rootNode = operationXML.firstChild;		
		
		rootNode.attributes.opcode = "remove";
		rootNode.attributes.arg = selectedItem.id;
		
		// Send XML
		operation_con.params = operationXML;
		operation_con.trigger();
		// 
		enableProgress(true, "Remove...");
				
	}
	
	// ----- Resultat sur XMLConnector -----
	public function doStatusOperationAction(stat:Object):Void {
		// Erreur sur code ASP
		if (stat.code != "StatusChange") {
			var error = "Erreur de l'application : " + stat.target._name + "/" + stat.code + "/" + stat.data.faultcode + "/" + stat.data.faultstring;
			enableProgress(false);
			showError(error);
		}	
	}
	
	public function doResultOperationAction():Void {
		// get result
		var resultXML:XML = operation_con.results;		
		var rootNode = resultXML.firstChild;
		
		enableProgress(false);
		
		var rcode = Number(rootNode.attributes.rcode);	
		var operation = rootNode.attributes.operation;
		
		if (operation == "remove") {
			if (rcode == 1 && (Number(rootNode.attributes.rarg) == 1)) {
				var id = rootNode.attributes.arg;
				
				var index = findItem(listing_dg, "id", id);
				listing_dg.removeItemAt(index);
		
				setMode("add");
				showMessage("Property '"+id+"' has been removed.", listing_dg);
			}
		}
		else if (operation == "update") {
			if (rcode == 1 && (Number(rootNode.attributes.rarg) == 1)) {
				var id = rootNode.attributes.arg;
				// -- update model --
				var selectedItem = listing_ds.currentItem; 
				var selectedIndex = listing_dg.selectedIndex;
				if (selectedItem.id == id) {
					var updateObject:Object = getEditObject();
					for (var f in updateObject) {
						var newValue = updateObject[f];		
						var oldValue = selectedItem[f];
						// Special case for date
						if (f == "listedOn") {
							if (newValue.valueOf() != oldValue.valueOf()) {
								selectedItem[f] = newValue;
							}
						}
						else if (newValue != oldValue) {
							selectedItem[f] = newValue;
						}
					}
					//
					showMessage("Property '"+id+"' has been updated.", listing_dg);
				}
			}		
		}
		else if (operation == "insert") {
			var rarg = rootNode.attributes.rarg;
			if (rcode < 0) {
				var errmsg = rootNode.attributes.errmsg;
				showError(errmsg);
			} 
			else if (rcode == 1 && (Number(rootNode.attributes.rarg) == 1)) {
				var id = rootNode.attributes.arg;
				var insertObject:Object = getEditObject();
				listing_ds.addItem(insertObject);
				//
				var index = findItem(listing_dg, "id", insertObject.id);
				listing_dg.vPosition = index;
				listing_dg.selectedIndex = index;
				listing_dg.dispatchEvent({type:"change"});
				//
				showMessage("Property '"+id+"' has been inserted.", listing_dg);
			}				
		}
	}

	// -----  -----
	public function findItem(datagrid:DataGrid, columnToSearch:String, id:String):Number {
		var index:Number = -1;
		var len = datagrid.dataProvider.length;
		for (var i = 0; i < len; i++){
			if (datagrid.getItemAt(i)[columnToSearch] == id){
				return i;
			}
		}
		return -1;
	}
		
	// -----  -----	
	public function trimSpacer(str:String):String {
		if (str == "") return "";
		for (var i:Number = 0; i < str.length && (str.charAt(i) == ' ' || str.charAt(i) == '\n' || str.charAt(i) == '\t' || str.charAt(i) == '\r'); i++);
		for (var j:Number = str.length - 1; j >= i && (str.charAt(j) == ' ' || str.charAt(j) == '\n' || str.charAt(j) == '\t' || str.charAt(j) == '\r'); j--);
		return str.substring(i, ++j);
	}
	// -----  -----
	private function enableProgress(enabled:Boolean, label:String):Void {
		(rootForm).enableProgress(enabled, label);
	}
	
	private function showError(message:String):Void {
		var window:Alert = Alert.show(	message, 
										"Application Error                     ", 
										Alert.OK, this);
		window.startDragging = function() {};
		(rootForm).setLocationRelativeTo(window, null);	
	}
	
	private function showMessage(message:String, mc:Object):Void {
		var window:Alert = Alert.show(message, 
										"Application Message                     ", 
										Alert.OK, this);
		window.startDragging = function() {};
		(rootForm).setLocationRelativeTo(window, (mc == undefined ? null : mc));	
	}
}
